



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>nyoj 84阶乘后0的个数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">nyoj 84阶乘后0的个数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 18:58:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>描述</p>
<p>计算n!的十进制表示最后有多少个0</p>
<dl>
<dt>输入</dt>
<dd>第一行输入一个整数N表示测试数据的组数(1&lt;=N&lt;=100)<br />每组测试数据占一行，都只有一个整数M(0&lt;=M&lt;=10000000)</dd>
<dt>输出</dt>
<dd>输出M的阶乘的十进制表示中最后0的个数<br />比如5!=120则最后的0的个数为1</dd>
<dt>样例输入</dt>
<dd>
<pre class="prettyprint linenums">6<br />
3<br />
60<br />
100<br />
1024<br />
23456<br />
8735373</pre>
</dd>
</dl>
<pre class="prettyprint linenums">分析： <a href="http://www.cnblogs.com/hansongjiang/archive/2014/05/06.html" rel="external nofollow noreferrer">http://www.cnblogs.com/hansongjiang/archive/2014/05/06.html</a></pre>
<pre class="prettyprint linenums">0来源于2*5，且将N!中分解后，2的个数大于5的个数所有，0的个数就等于N!中银子5的个数。</pre>
<pre class="prettyprint linenums">f(n!)=1*2*3*4*5*6*7*&hellip;(2*5)&hellip;(3*5)***(4*5) &hellip;.(k*5)* &hellip; n</pre>
<pre class="prettyprint linenums">      只考虑5的倍数：其他的必然没有5.</pre>
<pre class="prettyprint linenums">       抽取出来：</pre>
<pre class="prettyprint linenums">5*（1*2*3*k*） （其他的数） 现在已经有k个5了，但是K！中可能含有5，公式为</pre>
<pre class="prettyprint linenums">f(n)=k+f(k!) k=n/5;</pre>
<pre class="prettyprint linenums">k&lt;5,时候，没有0，所以f(n!)=0;k&lt;=4;</pre>
<pre class="prettyprint linenums">递归写法就很简单了。</pre>
<pre class="prettyprint linenums">int fun(int n)</pre>
<pre class="prettyprint linenums">{</pre>
<pre class="prettyprint linenums">if(n&lt;=4) return 0;</pre>
<pre class="prettyprint linenums">else return fun(n/5)+n/5;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums">仔细分析后，其实最终就是求N!因子5的个数。</pre>
<div>
<pre class="prettyprint linenums">private static int fun2(int n) {<br />
        // TODO Auto-generated method stub<br />
        int count=0;<br />
        for(int i=5;i&lt;=n;i=i+5)<br />
        {<br />
            if(i%5==0)<br />
            {<br />
            int j=i/5;<br />
                count++;<br />
                while(j%5==0)<br />
                {<br />
                    count++;<br />
                    j=j/5;

                }

            }

        }<br />
        return count;

    }</pre>
</div>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">在nyoj 提交之后发现，递归的效果还不错。</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/570103/201405/061132208851272.png" /></pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4n0g39.html">Linux学习 ：移植linux-4&period;7&period;4到JZ2440开发板</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22evxq.html">Eclipse中web项目部署至Tomcat步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk5o58.html">Task set generation</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lnjy9.html">Twitter全局唯一ID生成算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwjegq.html">LinkedList的实现原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zzyz59.html">转！！MAC和PHY的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyddepdq.html">3&period;2 Git 分支 - 分支的新建与合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlkve9.html">CSS图片垂直居中方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnzjk8.html">Codevs 5126 推销员 2015年NOIP全国联赛普及组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd0wwxq.html">&lbrack;转载&rsqb;MongoDB的&dollar;inc修改器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2yxe9.html">ASPNETMVC多语言方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdeyl8.html">Hadoop 2&period;x&lpar;YARN&rpar;安装配置LZO</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzm6508.html">kafka&lowbar;2&period;11-0&period;10&period;0&period;0安装步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/9507p0e8.html">（10&period;23）Java小知识！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp60dj9.html">快速搭建CentOS&plus;ASP&period;NET Core环境支持WebSocket</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj2y0z8.html">&lbrack;BJOI2017&rsqb;树的难题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7r628.html">python基础语法、数据结构、字符编码、文件处理 练习题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjj13q.html">第2周个人作业：WordCount</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1pyj09.html">poi设置打印页页脚和页数设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwgovz9.html">html页面调用js文件里的函数报错--&amp;gt&semi;方法名 is not defined处理方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z1lzzn9.html">Cassandra1&period;2文档学习（5）&mdash;&mdash; Snitch</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok2e459.html">SQL技术内幕四</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v1gx38.html">VC&plus;&plus;对话框中添加状态栏的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mjrkkq.html">Super Hide IP 3&period;4&period;7&period;8允许您以匿名方式进行网上冲浪、 保持隐藏您的 IP 地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v1gwo8.html">Linux下GPIO驱动（一）  ----一个简单的LED驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v1zz38.html">Unity3d Shader开发（三）Pass（Alpha testing ）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdwove8.html">统计 iOS 设备锁定、解锁次数－b</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ogom39.html">System&period;out&period;println&lpar;对象&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xy0308.html">HDU4521&plus;线段树&plus;dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vlmdo8.html">android Failure &lbrack;INSTALL&lowbar;FAILED&lowbar;OLDER&lowbar;SDK&rsqb; 安装apk失败</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
